// Ejercicio 7_3
clear;
clc;
xdel(winsid())
// VALORES
Ra=0.48;
La=3e-3;
J=3e-2;
B1=1.1e-3;
Kt=0.68;
Kw=0.68;
N=0.1;
Ts=0.01;
// MATRICES
A=[-Ra/La,-Kw/La, 0; Kt/J, -B1/J, 0; 0, N, 0];
B=[1/La; 0; 0];
C=eye(3,3);
D=zeros(3,1);
// MODELO DE ESTADO CONTINUO A LAZO ABIERTO
P1=syslin("c",A,B,C,D);
P1
zpk(P1)
// SIMULACIÓN
tiempo=[0:0.002:0.5]; // Vector de Tiempos
u=ones(1,length(tiempo));
Y=csim(u,tiempo,P1); // Simulación
// GRÁFICO VARIABLES DE ESTADO A LAZO ABIERTO 
subplot(3,1,1)
plot2d(tiempo,Y(1,:),color("red"));
xgrid(color("gray"))
title('Respuesta de las variables de estado')
ylabel("Corriente");
subplot(3,1,2)
plot2d(tiempo,Y(2,:),color("blue"));
xgrid(color("gray"))
ylabel("Velocidad");
subplot(3,1,3)
plot2d(tiempo,Y(3,:),color("scilabgreen4"));
xgrid(color("gray"))
ylabel("Posición");
// MODELO DE ESTADO DISCRETO
clc;
xdel(winsid())
disp('Modelo de estado discreto');
P1_dis =dscr(P1,Ts)
Ad=P1_dis.a;
Bd=P1_dis.b;
Cd=[0 0 1];
Dd=[0];
P2_dis=syslin("d",Ad,Bd,Cd,Dd)
G2=ss2tf(P2_dis)
U=cont_mat(Ad,Bd)
det(U)
rg=rank(U)
if rg==size(Ad)(1) then
    disp("El sistema es controlable")
end
// CÁLCULO DE LAS MATRICES DEL MODELO CANÓNICO CONTROLABLE
clc;
den=coeff(G2.den)
num=coeff(G2.num)
Ac=[0,1,0;0,0,1;-den(1),-den(2),-den(3)]
Bc=[0;0;1]
// CONTROLABILIDAD DEL MODELO CANÓNICO CONTROLABLE
Ucc=cont_mat(Ac,Bc)
det(Ucc)
// MATRIZ DE TRANSFORMACIÓN
Qcc_1=Ucc*U^-1
// MATRIZ A TRANSFORMADA
Acc=Qcc_1*Ad*Qcc_1^-1
Bcc=Qcc_1*Bd
clc;
xdel(winsid());
/*SE DESEA PARA LAS VARIABLES DEL SISTEMA UNA RESPUESTA AL ESCALÓN CON 
UN SOBREPICO DEL 5% Y UN TIEMPO DE ESTABLECIMIENTO DE 0.1 SEGUNDOS.
SE VA A UTILIZAR UNA APROXIMACIÓN DE SEGUNDO ORDEN PARA CALCULAR LOS 
AUTOVALORES.
PARA EL TIEMPO DE ESTABLECIMIENTO Test=4/(Psi Wn)
PARA EL SOBREPICO SP= EXP(-Psi Pi/(1-Psi^2)^0.5)*/
SP=0.05;
Test=0.1;
// Test=1;   // Modificar para ver otra respuesta
Psi= sqrt((log(SP))^2/((log(SP))^2+%pi^2));
Psi
Wn = 4/(Psi*Test);
Wn
p1c = -Psi*Wn+%i*Wn*sqrt(1-Psi^2);
p2c = -Psi*Wn-%i*Wn*sqrt(1-Psi^2);
polos_c=[p1c,p2c]

// AUTOVALORES DISCRETOS
polos=[exp(p1c*Ts),exp(p2c*Ts)]
// ***********************************************************************
// CANCELANDO UN CERO DE LA TRANSFERENCIA
// ***********************************************************************
[ceros1,polos1,K1]=tf2zp(ss2tf(P2_dis))
// ELECCIÓN DEL CERO ESTABLE
for i=1:length(ceros1)
    if abs(ceros1(i))<1 then
        p3c=ceros1(i)
    end
end
p3c
polos=[exp(p1c*Ts),exp(p2c*Ts),p3c]
// CÁLCULO DE LA REALIMENTACIÓN
Pcr=poly(polos,"z","roots");    // Polinomio deseado
Pcm=poly(Ad,"z");               // Polinomio de la planta
Pcd=Pcr-Pcm;                    // Diferencia
Ktcc=coeff(Pcd)                 // Vector de realimentación del Mcc
Ktcc=ppol(Acc,Bcc,Pz)           // Vector de realimentación del Mcc por SciLab
Kt=Ktcc*Qcc_1                   // Vector realimentación para el modelo original
Kt1=ppol(P2_dis.a,P2_dis.b,polos)// Vector de realimentación por SciLab
// RESPUESTA TRANSITORIA DE LAZO CERRADO
Alc=(P2_dis.a-P2_dis.b*Kt1)      // Matriz de la planta a lazo cerrado
Blc=P2_dis.b
Clc=[[0,0,1];-Kt1]
Dlc=[0;1]
P4_dis=syslin("d",Alc,Bd,Clc,Dlc); // Modelo de Lazo Cerrado
// SIMULACIÓN
tiempo=[0:Ts:0.3]; // Vector de Tiempos
u=ones(1,length(tiempo));
Y=dsimul(P4_dis,u); // Simulación
// GRÁFICO VARIABLES DE ESTADO A LAZO CERRADO 
xdel(winsid());
subplot(2,1,1)
plot2d(tiempo,Y(1,:),color("red"));
xgrid(color("gray"))
title('Respuesta de las variables de estado')
ylabel("Posición");
subplot(2,1,2)
plot2d(tiempo,Y(2,:),color("blue"));
xgrid(color("gray"))
ylabel("Control");
// AJUSTE DE LA GANANCIA
Plc=syslin("d",Alc,P2_dis.b,P2_dis.c,P2_dis.d) // Modelo de Lazo Cerrado
Ki=horner(ss2tf(Plc),1)          // Ganancia de Lazo Cerrado
A0=1/Ki                          // Ganancia del controlador
Kt0=Kt1/A0                       // Vector con ajuste de ganancia
// SIMULACIÓN
Clc=[[0,0,1];-Kt1]
Dlc=[0;A0]
P4_dis=syslin("d",Alc,A0*Bd,Clc,Dlc); // Modelo de Lazo Cerrado
tiempo=[0:Ts:0.3]; // Vector de Tiempos
u=ones(1,length(tiempo));
Y=dsimul(P4_dis,u); // Simulación
// FUNCION DE TRANSFRENCIA
G4=ss2tf(P4_dis);
zpk(G4)
// GRÁFICO VARIABLES DE ESTADO A LAZO CERRADO.
xdel(winsid());
subplot(2,1,1)
plot2d(tiempo,Y(1,:),color("red"));
xgrid(color("gray"))
title('Respuesta de las variables de estado')
ylabel("Posición");
subplot(2,1,2)
plot2d(tiempo,Y(2,:),color("blue"));
xgrid(color("gray"))
ylabel("Control");
// LUGAR DE RAICES
xdel(winsid())
Clc=Kt1;
P5_dis=syslin("d",Ad,Bd,Clc,Dd);
GH=ss2tf(P5_dis);
zpk(GH)
evans(GH,3)
xgrid(color("gray"))
clc
// ***********************************************************************
// UBICANDO UN POLO DE LA TRANSFERENCIA EN ALTA FRECUENCIA
// ***********************************************************************
p3c=-10*Psi*Wn
polos=[exp(p1c*Ts) exp(p2c*Ts) exp(p3c*Ts)]
// CÁLCULO DE LA REALIMENTACIÓN
Pcr=poly(polos,"z","roots");    // Polinomio deseado
Pcm=poly(Ad,"z");               // Polinomio de la planta
Pcd=Pcr-Pcm;                    // Diferencia
Ktcc=coeff(Pcd)                 // Vector de realimentación del Mcc
Ktcc=ppol(Acc,Bcc,Pz)           // Vector de realimentación del Mcc por SciLab
Kt=Ktcc*Qcc_1                   // Vector realimentación para el modelo original
Kt1=ppol(P2_dis.a,P2_dis.b,polos)// Vector de realimentación por SciLab
// AJUSTE DE LA GANANCIA
Alc=(P2_dis.a-P2_dis.b*Kt1)      // Matriz de la planta a lazo cerrado
Plc=syslin("d",Alc,P2_dis.b,P2_dis.c,P2_dis.d) // Modelo de Lazo Cerrado
Ki=horner(ss2tf(Plc),1)          // Ganancia de Lazo Cerrado
A0=1/Ki                          // Ganancia del controlador
Kt0=Kt1/A0                       // Vector con ajuste de ganancia
Alc=(P2_dis.a-P2_dis.b*Kt1)      // Matriz de la planta a lazo cerrado
Blc=P2_dis.b
Clc=[[0,0,1];-Kt1]
Dlc=[0;1]
P4_dis=syslin("d",Alc,Bd,Clc,Dlc); // Modelo de Lazo Cerrado
// SIMULACIÓN
tiempo=[0:Ts:0.3]; // Vector de Tiempos
u=ones(1,length(tiempo));
Y=dsimul(P4_dis,u); // Simulación
// GRÁFICO VARIABLES DE ESTADO A LAZO ABIERTO 
xdel(winsid());
subplot(2,1,1)
plot2d(tiempo,Y(1,:),color("red"));
xgrid(color("gray"))
title('Respuesta de las variables de estado')
ylabel("Posición");
subplot(2,1,2)
plot2d(tiempo,Y(2,:),color("blue"));
xgrid(color("gray"))
ylabel("Control");
// AJUSTE DE LA GANANCIA
Plc=syslin("d",Alc,P2_dis.b,P2_dis.c,P2_dis.d) // Modelo de Lazo Cerrado
Ki=horner(ss2tf(Plc),1)          // Ganancia de Lazo Cerrado
A0=1/Ki                          // Ganancia del controlador
Kt0=Kt1/A0                       // Vector con ajuste de ganancia
// SIMULACIÓN
Clc=[[0,0,1];-Kt1]
Dlc=[0;A0]
P4_dis=syslin("d",Alc,A0*Bd,Clc,Dlc); // Modelo de Lazo Cerrado
tiempo=[0:Ts:0.3]; // Vector de Tiempos
u=ones(1,length(tiempo));
Y=dsimul(P4_dis,u); // Simulación
// FUNCION DE TRANSFRENCIA
G4=ss2tf(P4_dis);
zpk(G4)
// GRÁFICO VARIABLES DE ESTADO A LAZO ABIERTO 
xdel(winsid());
subplot(2,1,1)
plot2d(tiempo,Y(1,:),color("red"));
xgrid(color("gray"))
title('Respuesta de las variables de estado')
ylabel("Posición");
subplot(2,1,2)
plot2d(tiempo,Y(2,:),color("blue"));
xgrid(color("gray"))
ylabel("Control");
// LUGAR DE RAICES
xdel(winsid())
Clc=Kt1;
P5_dis=syslin("d",Ad,Bd,Clc,Dd);
GH=ss2tf(P5_dis);
zpk(GH)
evans(GH,3)
xgrid(color("gray"))
